﻿$__author__ = "Shagun Agrawal <shaguna@chelsio.com"
$Global:__version__ = "3.0"
$Global:__is_nano  = "empty"
$Global:__t5_cards = @{
    # For internal use only don't modify this.
}

$Global:__t5_parts = @{
}

$Global:__t5_vpd_map = @{
}

$Global:__t5_vpd_revmap = @{
}


$Global:__sys_drive = (Get-ChildItem Env:\SystemDrive).Value

$Global:__vpd_default = @{

        "T580-CR"    = "t580_cr_variable_2133_vpd.bin";
        "T580-LP-CR" = "t580_lp_cr_variable_2133_vpd.bin";
        "T580-SO-CR" = "t580_lp_so_variable_vpd.bin";
        "T580-OCP-SO"= "t580_ocp_so_2x40g_vpd.bin";
}

$Global:__vpd_spider = @{
        
        "T580-CR"    = "t580_cr_spider_variable_2133_vpd.bin";
        "T580-LP-CR" = "t580_lp_cr_spider_variable_2133_vpd.bin";
        "T580-SO-CR" = "t580_so_spider_variable_2133_vpd.bin";
        "T580-OCP-SO"= "t580_ocp_so_4x10g_vpd.bin";
}

$Global:__vpd_qsa = @{
    
        "T580-CR"    = "t580_cr_qsa_variable_2133_vpd.bin";
        "T580-LP-CR" = "t580_lp_cr_qsa_variable_2133_vpd.bin";
        "T580-SO-CR" = "t580_lp_so_qsa_variable_vpd.bin";
}

$Global:__sriov = @{

       "T502-BT"    = "t502_bt_init_gen3_150mhz_Pf4vf.bin";
       "T520-BT"    = "t520_bt_init_gen3_250_820_Pf4vf.bin";
       "T520-CR"    = "t520_cr_init_gen3_250_825_Pf4vf.bin";
       "T520-LL-CR" = "t520_ll_init_gen3_650_1075_Pf4vf.bin";
       "T520-SO"    = "t520_so_init_gen3_250_825_Pf4vf.bin";
       "T522-CR"    = "t522_cr_init_gen3_500mhz_Pf4vf.bin";
       "T540-CR"    = "t540_cr_init_gen3_500_825_Pf4vf.bin";
       "T580-CR"    = "t580_cr_init_gen3_500Mhz_Pf4vf.bin";
       "T580-LP-CR" = "t580_lp_cr_init_gen3_500Mhz_Pf4vf.bin";
       "T580-SO-CR" = "t580_lp_so_init_gen3_500Mhz_Pf4vf.bin";
       "T580-OCP-SO"= "t580_ocp_so_init_gen3_500Mhz_Pf4vf.bin";
       "T520-OCP-SO"= "t520_ocp_init_gen3_250_825_Pf4vf.bin";
       "T540-BT"    = "t540_bt_init_gen3_500_820_Pf4vf.bin";
}

$Global:__default_init = @{
    
       "T502-BT"    = "t502_bt_init_gen3_150mhz.bin";
       "T520-BT"    = "t520_bt_init_gen3_250_820.bin";
       "T520-CR"    = "t520_cr_init_gen3_250_825.bin";
       "T520-LL-CR" = "t520_ll_init_gen3_650_1075.bin";
       "T520-SO"    = "t520_so_init_gen3_250_825.bin";
       "T522-CR"    = "t522_cr_init_gen3_500mhz.bin";
       "T540-CR"    = "t540_cr_init_gen3_500_825.bin";
       "T580-CR"    = "t580_cr_init_gen3_500Mhz.bin";
       "T580-LP-CR" = "t580_lp_cr_init_gen3_500Mhz.bin";
       "T580-SO-CR" = "t580_lp_so_init_gen3_500Mhz.bin";
       "T580-OCP-SO"= "t580_ocp_so_init_gen3_500Mhz.bin";
       "T520-OCP-SO"= "t520_ocp_init_gen3_250_825.bin";
       "T540-BT"    = "t540_bt_init_gen3_500_820.bin";
}

$Global:device_map = @{

        # Maps device ids to human readable names.

        "B000"    = "Bypass Mode";
        "5400"    = "T580-dbg";
        "5401"    = "T520-CR";
        "5402"    = "T522-CR";
        "5403"    = "T540-CR";
        "5404"    = "T520-BCH";
        "5405"    = "T540-BCH";
        "5406"    = "T540-CH";
        "5407"    = "T520-SO";
        "5408"    = "T520-CX";
        "5409"    = "T520-BT";
        "540A"    = "T504-BT";
        "540B"    = "B520-SR";
        "540C"    = "B504-BT";
        "540D"    = "T580-CR";
        "540E"    = "T540-LP-CR";
        "540F"    = "Amsterdam";

        "5410"    = "T580-LP-CR";
        "5411"    = "T520-LL-CR";
        "5412"    = "T560-CR";
        "5413"    = "T580-CHR";
        "5414"    = "T580-SO-CR";
        "5415"    = "T502-BT";
        "5416"    = "T580-OCP-SO";
        "5417"    = "T520-OCP-SO";
        "5418"    = "T540-BT";

        "5480"    = "SECUI";
        "5481"    = "SECUI-LL";
        "5482"    = "SECUI-1G";

        "5483"    = "HUAWEI-T540-CANCELED";
        "5484"    = "HUAWEI-T580-CALCELED";
        "5485"    = "HUAWEI-3XT580-CANCELED";
        "5486"    = "HUAWEI-2XT580";
        "5487"    = "Dell Harpoon";
        "5488"    = "Xalyo T570";
        "5489"    = "KTFN T520";
        "5490"    = "KTFN T540";

        "5491"    = "Huawei T522 LOM";
        "5492"    = "Datawise T520-XFI";
        
        <#
        "5800"    = "";
        "5801"    = "";
        "5802"    = "";
        "5803"    = "";
        "5804"    = "";
        "5805"    = "";
        "5806"    = "";
        "5807"    = "";
        "5808"    = "";
        "5809"    = "";
        "580A"    = "";
        "580B"    = "";
        "580C"    = "";
        "580D"    = "";
        "580E"    = "";
        "5810"    = "";
        "5811"    = "";
        "5812"    = "";
        "5813"    = "";
        "5814"    = "";
        "5815"    = "";
        "5816"    = "";
        "5817"    = "";
        "5818"    = "";
        "5880"    = "";
        "5881"    = "";
        "5883"    = "";
        "5884"    = "";
        "5885"    = "";
        "5886"    = "";
        "5887"    = "";
        "5888"    = "";
        "5889"    = "";
        "5890"    = "";
        #>
        
}

function is_cxgbtool_present ()
{
        return Test-Path C:\Windows\System32\cxgbtool.exe
}
  
function is_cxgbnano_present()
{
        return Test-Path C:\Windows\System32\cxgbnano.exe
}

function is_ms_nano_server()
{
        
        if ($Global:__is_nano -eq "empty") {
            Write-Host "    1.  Windows GUI"
            Write-Host "    2.  Windows Nano Server"
            $Global:__is_nano = READ-HOST 'Input'

        }

        if ($Global:__is_nano -eq '1') {
            return 0
        }
        elseif ($Global:__is_nano -eq '2') {
            return 1
        }
        else {
            Write-Host "Wrong input"
            exit(1)
        }
        
}

function get_cxgbtool()
{
    if (is_ms_nano_server) {
        return "cxgbnano.exe"
    }
    else {
        return "cxgbtool.exe"
    }
}

function get_t5_count ()
{
        if ((Test-Path "HKLM:\SYSTEM\CurrentControlSet\Services\chvbd\Enum") -eq $false) {
            return $false
        }
        
        $out = Get-ItemProperty "HKLM:\SYSTEM\CurrentControlSet\Services\chvbd\Enum"      
        return $out.Count
}


function __extract_devid ([string] $str)
{
        
        $tmp = $str -replace '\s+', ' '
        return $tmp.Split(' ')[1].trim().ToString()
}


function __extract_partno ([string] $str)
{
       
        $tmp = $str -replace '\s+', ' '
        return $tmp.Split(' ')[1].trim().ToString()
}


function get_pci_device ([int] $num)
{ 
        $cmd = "$(get_cxgbtool) vbd$num version"
        
        $out = Invoke-Expression -Command $cmd
      
        for ($i=0; $i -le $out.Length-1; $i++){
               
                if ($out[$i].Contains("DeviceId:") -eq $true){
                        $dev_id = __extract_devid $out[$i]
                }

                if ($out[$i].Contains("S/N:") -eq $true){
                        $part = __extract_partno $out[$i]     
                }
        }
        
        return $dev_id, $part
}


function __is_t5 ([string] $device)
{
        foreach ( $key in ($device_map.GetEnumerator())){
                if ($device.Contains($key.name.ToLower())){
                    return $true, $key.value
            }
        }

}


function __add_device ([int] $vpd_count, [int]$count, [string] $name, [string] $part)
{
        $Global:__t5_cards.Add($vpd_count, $name)
        $Global:__t5_parts.Add($vpd_count, "S/N:" + $part)
        $Global:__t5_vpd_map.Add($vpd_count, $count)
        $Global:__t5_vpd_revmap.Add($count, $vpd_count)
}


function filter_t5 ([int] $count)
{
        $t5_count = 0
        for ($i=0; $i -le $count; $i++){
                $dev, $part = get_pci_device ($i)
                $st, $name = __is_t5 ($dev)
                if ($st -eq $true) {
                        __add_device $i $t5_count $name $part
                        $t5_count +=1
                }

        }
}

function choose_adapter ()
{
        Write-Host "`nSelect the Adapter"
        foreach ( $key in ($__t5_cards.GetEnumerator() | Sort-Object Name)){
                $cnt = [convert]::ToInt32($key.name, 10)              
                $display = $Global:__t5_vpd_map.Item($cnt) +1
                $tmp = "{0,7}{1,2}{2,1}{3,-15}{4,-18}" -f ` "", $display, ".", $key.value, $Global:__t5_parts.Item($cnt)
           
                Write-Host $tmp
        } 

        $choice = Read-Host "Input "
        try {
                $choice = [convert]::ToInt32($choice, 10)
        }
        catch {
                Write-Host "Please enter valid input to select adapter"
                exit (1)
        }

        if (-Not ($choice -ge 1 -and $choice -le  $__t5_cards.Count)){
                Write-Host "Please enter valid input to select adapter"
                exit (1)
        }

        return $Global:__t5_vpd_revmap.item($choice-1)


}

function choose_vpd()
{
        Write-Host "`nChoose the type:"
        Write-Host "`t1. DEFAULT (2 x 40G)"
        Write-Host "`t2. SPIDER  (4 x 10G)"
        Write-Host "`t3. QSA     (2 x 10G)"
        
        $adapter_name = $Global:__t5_cards.Item($adapter)  

        $choice = Read-Host "Input "
        try {
                $choice = [convert]::ToInt32($choice, 10)
        }
        catch {
                Write-Host "Please enter valid input !!"
                exit (1)
        }
        if ($choice -ne 1 -and $choice -ne 2 -and $choice -ne 3){
                Write-Host "Please enter valid input !!"
                exit(1)
        }

        if ($adapter_name -eq "T580-OCP-SO" -and $choice -eq 3) {
                Write-Host "QSA is not supported for T580-OCP-SO"
                exit(1)
        }

        return $choice
}


function is_t580([string] $adapter_name)
{
        if($adapter_name -eq "T580-LP-CR" -or $adapter_name -eq "T580-CR" -or $adapter_name -eq "T580-SO-CR" -or $adapter_name -eq "T580-OCP-SO"){
                return 1
        }
        return 0;

}

function choose_init ()
{
        Write-Host "`nChoose the configuration type:"
        Write-Host "`t1. NON-SRIOV (Default)"
        Write-Host "`t2. SRIOV"
        
        $adapter_name = $Global:__t5_cards.Item($adapter)
        if (is_t580($adapter_name)){
                Write-Host "`t3. Port settings"
        }

        $choice = Read-Host "Input "
        try {
                $choice = [convert]::ToInt32($choice, 10)
        }
        catch {
                Write-Host "Please enter valid input !!"
                exit (1)
        }
        if ($choice -ne 1 -and $choice -ne 2 -and $choice -ne 3){
                Write-Host "Please enter valid input !!"
                exit(1)
        }
        return $choice
}

function __yes_no_flash ()
{
        $choice = Read-Host "Do you want to continue (y/n)"

        Set-Content tmp $choice
        if ($choice  -eq 'y' -or $choice -eq 'Y'){
                return $true
        }
        if ($choice -ne 'n' -and $choice -ne 'N'){
                Write-Host "Invalid input!"
        }
        
        Remove-Item tmp
        exit(1)
}
    
function __flash ($vpd, $path)
{     
        $out = __verify $vpd $path $false
        if ( ($out -join '`n').Contains("FAILED") -eq $false) {
                Write-Host "`nThe selected configuration is already present." -ForegroundColor Green
                exit(0)
        }

        $out = [string]

        # Exit if the user says not to flash
        $choice = __yes_no_flash 
 
        $path = "`"$path`""
        # Start the process and attact the user input as the
        # standard input file. 
        
        if ( is_ms_nano_server ) {
            Start-Process (get_cxgbtool) -ArgumentList vbd$vpd,serialinit,write,$path,force -RedirectStandardInput tmp -RedirectStandardOutput out0 -wait -NoNewWindow
        }
        else {
            Start-Process (get_cxgbtool) -ArgumentList vbd$vpd,serialinit,write,$path -RedirectStandardInput tmp -RedirectStandardOutput out0 -wait -NoNewWindow
        }

        $out = Get-Content out0
        #Write-Host `n

        Remove-Item tmp
        Remove-Item out0
        
        if ( ($out -join '`n').Contains('fail') -eq $true){
                Write-Host "Flashing failed with error `n $out" -ForegroundColor Red
                exit(1)
        }
       
}

function __flash_vpd ($vpd, $path)
{     
        $out = __verify_vpd $vpd $path $false
        if ( ($out -join '`n').Contains("FAILED") -eq $false) {
                Write-Host "`nThe selected configuration is already present." -ForegroundColor Green
                exit(0)
        }

        $out = [string]

        # Exit if the user says not to flash
        $choice = __yes_no_flash 
 
        $path = "`"$path`""
        # Start the process and attact the user input as the
        # standard input file. 
        if ( is_ms_nano_server ) {
            Start-Process (get_cxgbtool) -ArgumentList vbd$vpd,vpd,write,$path,force -RedirectStandardInput tmp -RedirectStandardOutput out0 -Wait -NoNewWindow
        }
        else {
            Start-Process (get_cxgbtool) -ArgumentList vbd$vpd,vpd,write,$path -RedirectStandardInput tmp -RedirectStandardOutput out0 -Wait -NoNewWindow
        } 

        $out = Get-Content out0
      
        Remove-Item tmp
        Remove-Item out0
      
        if ( ($out -join '`n').Contains('fail') -eq $true){
                Write-Host "Flashing failed with error `n $out" -ForegroundColor Red
                exit(1)
        }
       
}

function __verify_vpd ($vpd, $path, $debug)
{
      
        #if ( $debug -eq $true){
        #        Write-Host -NoNewline "`nVerifying the existing configuration... " -ForegroundColor Green
        #}

        $cmd = "$(get_cxgbtool) vbd$vpd vpd verify `"$path`""
        
        $out = Invoke-Expression -Command $cmd 
       
        return $out

}


function __verify ($vpd, $path, $debug)
{
      
        #if ( $debug -eq $true){
        #        Write-Host -NoNewline "`nVerifying the existing configuration... " -ForegroundColor Green
        #}

        $cmd = "$(get_cxgbtool) vbd$vpd serialinit verify `"$path`""
        $out = Invoke-Expression -Command $cmd 
        #Write-Host $cmd
        return $out

}

function __get_default_init ([string] $adapter_name)
{
        $file_name = $Global:__default_init.Item($adapter_name)
        if ( (Test-Path  "$Global:__sys_drive\ChelsioUwire\Adapter Configuration\default\$file_name") -eq $true){
                return "$Global:__sys_drive\ChelsioUwire\Adapter` Configuration\default\$file_name"
        }
        elseif ( (Test-Path ".\default\$file_name") -eq $true){
                return  ".\default\$file_name"
        }
        else {
                return $file_name
        }
}


function __get_sriov  ([string] $adapter_name)
{

        $file_name = $Global:__sriov.Item($adapter_name)

        if ( (Test-Path "$Global:__sys_drive\ChelsioUwire\Adapter Configuration\SRIOV\$file_name") -eq $true){
                return "$Global:__sys_drive\ChelsioUwire\Adapter` Configuration\SRIOV\$file_name"
        }
        elseif ( (Test-Path ".\SRIOV\$file_name") -eq $true){
                return  ".\SRIOV\$file_name"
        }
        else {
                return $file_name
        }
}

 
function __check_init_path ($path)
{
        $ret = Test-Path $path 
        if ($ret -eq $false){
                Write-Host "Unable to find the bin file." -ForegroundColor Red
                exit (1)
        }

}

function __get_vpd([string] $adapter_name, [int] $vpd_choice)
{

        if ($vpd_choice -eq 1){
                $file_name = $Global:__vpd_default.Item($adapter_name)
                                
        }
        elseif ($vpd_choice -eq 2){
                 $file_name = $Global:__vpd_spider.Item($adapter_name)
        }
        elseif ($vpd_choice -eq 3){
                 $file_name = $Global:__vpd_qsa.Item($adapter_name)
        }

        if ( (Test-Path "$Global:__sys_drive\ChelsioUwire\Adapter Configuration\Port Settings\$file_name") -eq $true){
                return "$Global:__sys_drive\ChelsioUwire\Adapter` Configuration\Port` Settings\$file_name"
        }
        elseif ( (Test-Path ".\Port Settings\$file_name") -eq $true){
                return  ".\Port` Settings\$file_name"
        }
        else {
                return $file_name
        }
}

function flash ([int] $adapter, [int] $init)
{
        $adapter_name = $Global:__t5_cards.Item($adapter)
        $t5 = is_t580 $adapter_name
        
        if ($init -eq 1){
                $init_file = __get_default_init ($adapter_name)    
        }elseif ($init -eq 2){
                $init_file = __get_sriov ($adapter_name)
                #Write-Host "adap $adapter_name"
                #Write-Host "sriov init $init_file"
                
        }elseif ($init -eq 3 -and $t5){
                $vpd_choice = choose_vpd
                $init_file = __get_vpd $adapter_name $vpd_choice            

        }else {
                Write-Host "Please Enter valid input !!!"
                exit(1)
        }

        __check_init_path ($init_file)
        
        if ($init -eq 3){
                __flash_vpd $adapter $init_file
                $out = __verify_vpd $adapter $init_file $true
        }else {
                __flash $adapter $init_file
                $out = __verify $adapter $init_file $true
        }
        
        #Write-Host $out
        if (($out -join '`n').Contains("FAILED")) {
                #Write-Host $out
                Write-Host "`nVerification Failed." -ForegroundColor Red
                exit(1)
        }
        else {
                Write-Host "Successfully updated the selected configuration type." -ForegroundColor Green
                Write-Host "`nVerification: Passed" -ForegroundColor Green
                Write-Host "`nPlease reboot the machine for changes to take effect." -ForegroundColor Red
        }
}

function main (){

        if ((is_ms_nano_server) -and ((is_cxgbnano_present) -eq $false) ) {
                Write-Host "cxgbnano is not present in system32 folder." -ForegroundColor Red
                exit(1)
        }


        if (!(is_ms_nano_server) -and ((is_cxgbtool_present ) -eq $false)){
                Write-Host "cxgbtool is not present in system32 folder." -ForegroundColor Red
                exit(1)
        }
        
        Write-Host "`nchelsio_adapter_config Version $Global:__version__`n"
        Write-Host "Please stop all the traffic on Chelsio adapters before updating !!" -ForegroundColor Red
        $count = get_t5_count
        filter_t5 ($count)
        $adapter = choose_adapter
        $init = choose_init
 
        flash $adapter $init
}

main 

# SIG # Begin signature block
# MIIYAgYJKoZIhvcNAQcCoIIX8zCCF+8CAQExDzANBglghkgBZQMEAgEFADB5Bgor
# BgEEAYI3AgEEoGswaTA0BgorBgEEAYI3AgEeMCYCAwEAAAQQH8w7YFlLCE63JNLG
# KX7zUQIBAAIBAAIBAAIBAAIBADAxMA0GCWCGSAFlAwQCAQUABCBmuQwlg+F3eait
# s4VZim9pXHvmbiblkJZ5vSr2Efe8VqCCExkwggPuMIIDV6ADAgECAhB+k+v7fMZO
# WepLmnfUBvw7MA0GCSqGSIb3DQEBBQUAMIGLMQswCQYDVQQGEwJaQTEVMBMGA1UE
# CBMMV2VzdGVybiBDYXBlMRQwEgYDVQQHEwtEdXJiYW52aWxsZTEPMA0GA1UEChMG
# VGhhd3RlMR0wGwYDVQQLExRUaGF3dGUgQ2VydGlmaWNhdGlvbjEfMB0GA1UEAxMW
# VGhhd3RlIFRpbWVzdGFtcGluZyBDQTAeFw0xMjEyMjEwMDAwMDBaFw0yMDEyMzAy
# MzU5NTlaMF4xCzAJBgNVBAYTAlVTMR0wGwYDVQQKExRTeW1hbnRlYyBDb3Jwb3Jh
# dGlvbjEwMC4GA1UEAxMnU3ltYW50ZWMgVGltZSBTdGFtcGluZyBTZXJ2aWNlcyBD
# QSAtIEcyMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAsayzSVRLlxwS
# CtgleZEiVypv3LgmxENza8K/LlBa+xTCdo5DASVDtKHiRfTot3vDdMwi17SUAAL3
# Te2/tLdEJGvNX0U70UTOQxJzF4KLabQry5kerHIbJk1xH7Ex3ftRYQJTpqr1SSwF
# eEWlL4nO55nn/oziVz89xpLcSvh7M+R5CvvwdYhBnP/FA1GZqtdsn5Nph2Upg4XC
# YBTEyMk7FNrAgfAfDXTekiKryvf7dHwn5vdKG3+nw54trorqpuaqJxZ9YfeYcRG8
# 4lChS+Vd+uUOpyyfqmUg09iW6Mh8pU5IRP8Z4kQHkgvXaISAXWp4ZEXNYEZ+VMET
# fMV58cnBcQIDAQABo4H6MIH3MB0GA1UdDgQWBBRfmvVuXMzMdJrU3X3vP9vsTIAu
# 3TAyBggrBgEFBQcBAQQmMCQwIgYIKwYBBQUHMAGGFmh0dHA6Ly9vY3NwLnRoYXd0
# ZS5jb20wEgYDVR0TAQH/BAgwBgEB/wIBADA/BgNVHR8EODA2MDSgMqAwhi5odHRw
# Oi8vY3JsLnRoYXd0ZS5jb20vVGhhd3RlVGltZXN0YW1waW5nQ0EuY3JsMBMGA1Ud
# JQQMMAoGCCsGAQUFBwMIMA4GA1UdDwEB/wQEAwIBBjAoBgNVHREEITAfpB0wGzEZ
# MBcGA1UEAxMQVGltZVN0YW1wLTIwNDgtMTANBgkqhkiG9w0BAQUFAAOBgQADCZuP
# ee9/WTCq72i1+uMJHbtPggZdN1+mUp8WjeockglEbvVt61h8MOj5aY0jcwsSb0ep
# rjkR+Cqxm7Aaw47rWZYArc4MTbLQMaYIXCp6/OJ6HVdMqGUY6XlAYiWWbsfHN2qD
# IQiOQerd2Vc/HXdJhyoWBl6mOGoiEqNRGYN+tjCCBKMwggOLoAMCAQICEA7P9DjI
# /r81bgTYapgbGlAwDQYJKoZIhvcNAQEFBQAwXjELMAkGA1UEBhMCVVMxHTAbBgNV
# BAoTFFN5bWFudGVjIENvcnBvcmF0aW9uMTAwLgYDVQQDEydTeW1hbnRlYyBUaW1l
# IFN0YW1waW5nIFNlcnZpY2VzIENBIC0gRzIwHhcNMTIxMDE4MDAwMDAwWhcNMjAx
# MjI5MjM1OTU5WjBiMQswCQYDVQQGEwJVUzEdMBsGA1UEChMUU3ltYW50ZWMgQ29y
# cG9yYXRpb24xNDAyBgNVBAMTK1N5bWFudGVjIFRpbWUgU3RhbXBpbmcgU2Vydmlj
# ZXMgU2lnbmVyIC0gRzQwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAwggEKAoIBAQCi
# Yws5RLi7I6dESbsO/6HwYQpTk7CY260sD0rFbv+GPFNVDxXOBD8r/amWltm+YXkL
# W8lMhnbl4ENLIpXuwitDwZ/YaLSOQE/uhTi5EcUj8mRY8BUyb05Xoa6IpALXKh7N
# S+HdY9UXiTJbsF6ZWqidKFAOF+6W22E7RVEdzxJWC5JH/Kuu9mY9R6xwcueS51/N
# ELnEg2SUGb0lgOHo0iKl0LoCeqF3k1tlw+4XdLxBhircCEyMkoyRLZ53RB9o1qh0
# d9sOWzKLVoszvdljyEmdOsXF6jML0vGjG/SLvtmzV4s73gSneiKyJK4ux3DFvk6D
# Jgj7C72pT5kI4RAocqrNAgMBAAGjggFXMIIBUzAMBgNVHRMBAf8EAjAAMBYGA1Ud
# JQEB/wQMMAoGCCsGAQUFBwMIMA4GA1UdDwEB/wQEAwIHgDBzBggrBgEFBQcBAQRn
# MGUwKgYIKwYBBQUHMAGGHmh0dHA6Ly90cy1vY3NwLndzLnN5bWFudGVjLmNvbTA3
# BggrBgEFBQcwAoYraHR0cDovL3RzLWFpYS53cy5zeW1hbnRlYy5jb20vdHNzLWNh
# LWcyLmNlcjA8BgNVHR8ENTAzMDGgL6AthitodHRwOi8vdHMtY3JsLndzLnN5bWFu
# dGVjLmNvbS90c3MtY2EtZzIuY3JsMCgGA1UdEQQhMB+kHTAbMRkwFwYDVQQDExBU
# aW1lU3RhbXAtMjA0OC0yMB0GA1UdDgQWBBRGxmmjDkoUHtVM2lJjFz9eNrwN5jAf
# BgNVHSMEGDAWgBRfmvVuXMzMdJrU3X3vP9vsTIAu3TANBgkqhkiG9w0BAQUFAAOC
# AQEAeDu0kSoATPCPYjA3eKOEJwdvGLLeJdyg1JQDqoZOJZ+aQAMc3c7jecshaAba
# tjK0bb/0LCZjM+RJZG0N5sNnDvcFpDVsfIkWxumy37Lp3SDGcQ/NlXTctlzevTcf
# Q3jmeLXNKAQgo6rxS8SIKZEOgNER/N1cdm5PXg5FRkFuDbDqOJqxOtoJcRD8HHm0
# gHusafT9nLYMFivxf1sJPZtb4hbKE4FtAC44DagpjyzhsvRaqQGvFZwsL0kb2yK7
# w/54lFHDhrGCiF3wPbRRoXkzKy57udwgCRNx62oZW8/opTBXLIlJP7nPf8m/PiJo
# Y1OavWl0rMUdPH+S4MO8HNgEdTCCBTAwggQYoAMCAQICEAQJGBtf1btmdVNDtW+V
# UAgwDQYJKoZIhvcNAQELBQAwZTELMAkGA1UEBhMCVVMxFTATBgNVBAoTDERpZ2lD
# ZXJ0IEluYzEZMBcGA1UECxMQd3d3LmRpZ2ljZXJ0LmNvbTEkMCIGA1UEAxMbRGln
# aUNlcnQgQXNzdXJlZCBJRCBSb290IENBMB4XDTEzMTAyMjEyMDAwMFoXDTI4MTAy
# MjEyMDAwMFowcjELMAkGA1UEBhMCVVMxFTATBgNVBAoTDERpZ2lDZXJ0IEluYzEZ
# MBcGA1UECxMQd3d3LmRpZ2ljZXJ0LmNvbTExMC8GA1UEAxMoRGlnaUNlcnQgU0hB
# MiBBc3N1cmVkIElEIENvZGUgU2lnbmluZyBDQTCCASIwDQYJKoZIhvcNAQEBBQAD
# ggEPADCCAQoCggEBAPjTsxx/DhGvZ3cH0wsxSRnP0PtFmbE620T1f+Wondsy13Hq
# dp0FLreP+pJDwKX5idQ3Gde2qvCchqXYJawOeSg6funRZ9PG+yknx9N7I5TkkSOW
# kHeC+aGEI2YSVDNQdLEoJrskacLCUvIUZ4qJRdQtoaPpiCwgla4cSocI3wz14k1g
# GL6qxLKucDFmM3E+rHCiq85/6XzLkqHlOzEcz+ryCuRXu0q16XTmK/5sy350OTYN
# kO/ktU6kqepqCquE86xnTrXE94zRICUj6whkPlKWwfIPEvTFjg/BougsUfdzvL2F
# sWKDc0GCB+Q4i2pzINAPZHM8np+mM6n9Gd8lk9ECAwEAAaOCAc0wggHJMBIGA1Ud
# EwEB/wQIMAYBAf8CAQAwDgYDVR0PAQH/BAQDAgGGMBMGA1UdJQQMMAoGCCsGAQUF
# BwMDMHkGCCsGAQUFBwEBBG0wazAkBggrBgEFBQcwAYYYaHR0cDovL29jc3AuZGln
# aWNlcnQuY29tMEMGCCsGAQUFBzAChjdodHRwOi8vY2FjZXJ0cy5kaWdpY2VydC5j
# b20vRGlnaUNlcnRBc3N1cmVkSURSb290Q0EuY3J0MIGBBgNVHR8EejB4MDqgOKA2
# hjRodHRwOi8vY3JsNC5kaWdpY2VydC5jb20vRGlnaUNlcnRBc3N1cmVkSURSb290
# Q0EuY3JsMDqgOKA2hjRodHRwOi8vY3JsMy5kaWdpY2VydC5jb20vRGlnaUNlcnRB
# c3N1cmVkSURSb290Q0EuY3JsME8GA1UdIARIMEYwOAYKYIZIAYb9bAACBDAqMCgG
# CCsGAQUFBwIBFhxodHRwczovL3d3dy5kaWdpY2VydC5jb20vQ1BTMAoGCGCGSAGG
# /WwDMB0GA1UdDgQWBBRaxLl7KgqjpepxA8Bg+S32ZXUOWDAfBgNVHSMEGDAWgBRF
# 66Kv9JLLgjEtUYunpyGd823IDzANBgkqhkiG9w0BAQsFAAOCAQEAPuwNWiSz8yLR
# FcgsfCUpdqgdXRwtOhrE7zBh134LYP3DPQ/Er4v97yrfIFU3sOH20ZJ1D1G0bqWO
# WuJeJIFOEKTuP3GOYw4TS63XX0R58zYUBor3nEZOXP+QsRsHDpEV+7qvtVHCjSSu
# JMbHJyqhKSgaOnEoAjwukaPAJRHinBRHoXpoaK+bp1wgXNlxsQyPu6j4xRJon89A
# y0BEpRPw5mQMJQhCMrI2iiQC/i9yfhzXSUWW6Fkd6fp0ZGuy62ZD2rOwjNXpDd32
# ASDOmTFjPQgaGLOBm0/GkxAG/AeB+ova+YJJ92JuoVP6EpQYhS6SkepobEQysmah
# 5xikmmRR7zCCBUgwggQwoAMCAQICEAWTh8BfNE4KO4ai6IxxdAswDQYJKoZIhvcN
# AQELBQAwcjELMAkGA1UEBhMCVVMxFTATBgNVBAoTDERpZ2lDZXJ0IEluYzEZMBcG
# A1UECxMQd3d3LmRpZ2ljZXJ0LmNvbTExMC8GA1UEAxMoRGlnaUNlcnQgU0hBMiBB
# c3N1cmVkIElEIENvZGUgU2lnbmluZyBDQTAeFw0xNjAzMjUwMDAwMDBaFw0xNzA1
# MzExMjAwMDBaMIGEMQswCQYDVQQGEwJVUzETMBEGA1UECBMKQ2FsaWZvcm5pYTES
# MBAGA1UEBxMJU3Vubnl2YWxlMSUwIwYDVQQKExxDaGVsc2lvIENvbW11bmljYXRp
# b25zLCBJbmMuMSUwIwYDVQQDExxDaGVsc2lvIENvbW11bmljYXRpb25zLCBJbmMu
# MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAmzoiymUFibv1BFOd42j/
# NDSjtZgt2AhsP2S2rG3+nEgulQFSAKch9MBl9wHDMrFgsqGpDJobre+GcbdTfF84
# kgtjEiHnmcgtnhJTyf9thzJU6djuFmJ7IAYzBZhnguPdQU4lz59BjJHFFUSbtPjH
# PM1dDeiFsQNFcSf8pv5cnuKNh957c4CzmmqtpkLmRPpnI+uvM5xnOp/9X8OSMOl0
# 1/0vekw+8STN2IK+2701uHT24RdrH/Jk3MTm+IzB3iC8Y1RCRbbltioLOkg5KHk+
# PuRjCaz7YnElpjJ6tD+9myLt3CQIwgzFVS2TpplR7H+NM3I1nX15tpKds1e/AcFd
# 0QIDAQABo4IBxTCCAcEwHwYDVR0jBBgwFoAUWsS5eyoKo6XqcQPAYPkt9mV1Dlgw
# HQYDVR0OBBYEFAfyoaP1XN38xeVDl9sXJUak1zXVMA4GA1UdDwEB/wQEAwIHgDAT
# BgNVHSUEDDAKBggrBgEFBQcDAzB3BgNVHR8EcDBuMDWgM6Axhi9odHRwOi8vY3Js
# My5kaWdpY2VydC5jb20vc2hhMi1hc3N1cmVkLWNzLWcxLmNybDA1oDOgMYYvaHR0
# cDovL2NybDQuZGlnaWNlcnQuY29tL3NoYTItYXNzdXJlZC1jcy1nMS5jcmwwTAYD
# VR0gBEUwQzA3BglghkgBhv1sAwEwKjAoBggrBgEFBQcCARYcaHR0cHM6Ly93d3cu
# ZGlnaWNlcnQuY29tL0NQUzAIBgZngQwBBAEwgYQGCCsGAQUFBwEBBHgwdjAkBggr
# BgEFBQcwAYYYaHR0cDovL29jc3AuZGlnaWNlcnQuY29tME4GCCsGAQUFBzAChkJo
# dHRwOi8vY2FjZXJ0cy5kaWdpY2VydC5jb20vRGlnaUNlcnRTSEEyQXNzdXJlZElE
# Q29kZVNpZ25pbmdDQS5jcnQwDAYDVR0TAQH/BAIwADANBgkqhkiG9w0BAQsFAAOC
# AQEAhmYOVEkVSDyPyfRxgADQ+js71Lug0bZd5TRZYwq700hFcf6ihs95sO1ACrci
# IidKYT6oX0Pu3y/kc4n3Ss0KK0GbeJS1lOOjkF8E3tKUV+abD1W6qChGKVKzydq2
# YbPInr3lu7t9SJvd5to2ZWwZW2S2yd8EGpU47iefV+CvKuZj4k3mIWMLY+vlzg7u
# TI3ijYzRRH11NYl+Vu6msgZYce8JzE1Yr+ppbIm7O+cHvWj7niAAtCaFwTqC3jo2
# YSFPh5zAQxWEVLZzUIOKuFkVD3HU7AMSX6Hru0gfRzb0vP7xkckait44fqlDtG7B
# U6fw7wjRvKiJpe6axpFeBi8JmzGCBD8wggQ7AgEBMIGGMHIxCzAJBgNVBAYTAlVT
# MRUwEwYDVQQKEwxEaWdpQ2VydCBJbmMxGTAXBgNVBAsTEHd3dy5kaWdpY2VydC5j
# b20xMTAvBgNVBAMTKERpZ2lDZXJ0IFNIQTIgQXNzdXJlZCBJRCBDb2RlIFNpZ25p
# bmcgQ0ECEAWTh8BfNE4KO4ai6IxxdAswDQYJYIZIAWUDBAIBBQCgfDAQBgorBgEE
# AYI3AgEMMQIwADAZBgkqhkiG9w0BCQMxDAYKKwYBBAGCNwIBBDAcBgorBgEEAYI3
# AgELMQ4wDAYKKwYBBAGCNwIBFTAvBgkqhkiG9w0BCQQxIgQgbJbXGvoefi0TJmcC
# b8JD/KLrGNPc2ZAVGVFyLjyVStwwDQYJKoZIhvcNAQEBBQAEggEAMx5wkAWlCiRc
# vjHmeUYfEBLaU40oPimMDWqHKlIuCQhRwmvmKL9MG/O5nmhPDChAlRBDUAye74VZ
# xjnch9fA3nJL/WKtqbx/lHaMzNpPe0UZyPYYFuXT+kJ0KPAuvtVLq2SO19HFL9NH
# G/rgXgZRv/mWhgrEM3IRlaE4+DWmLmoCBsliX3e9D8nSxTZt4oW13ARRAhn20deU
# wtz/FDZvleum9CAyjubBh4mIcLCn/u0El+h29sXtkIPpZG0X/4vRNE3hdupSa0iM
# kqLBHNRRmsjKR8GxaUr8Di2OIPZB1ma9yHdGGf54gz2Au0pyJB6FWoQTda/KpDtv
# cqQGMo5yt6GCAgswggIHBgkqhkiG9w0BCQYxggH4MIIB9AIBATByMF4xCzAJBgNV
# BAYTAlVTMR0wGwYDVQQKExRTeW1hbnRlYyBDb3Jwb3JhdGlvbjEwMC4GA1UEAxMn
# U3ltYW50ZWMgVGltZSBTdGFtcGluZyBTZXJ2aWNlcyBDQSAtIEcyAhAOz/Q4yP6/
# NW4E2GqYGxpQMAkGBSsOAwIaBQCgXTAYBgkqhkiG9w0BCQMxCwYJKoZIhvcNAQcB
# MBwGCSqGSIb3DQEJBTEPFw0xNjEwMTQxMzI3MzdaMCMGCSqGSIb3DQEJBDEWBBRe
# 2pyeyhlCaJEd18wfVtKHvXK5JDANBgkqhkiG9w0BAQEFAASCAQASpsZmAms17d/R
# vl4rtXRSB0kJ/QHZFMfCMQbKQoZfh3g5JF848cuZ3R1799QPfUjVVTs/lBq1Nclk
# h4W54lIniMPm03EJOUlwu/x32ZZMT8fiQrPl6PL7PrQwIa+uIXpEIfEaXHmHTRSv
# cMPStQAj10b7dybXAF82qjRj63wB0WjUh3BCLVwRx6/5Pmd6fN4fCM2J9/DQKf0N
# 45lHc/9Bw6BrqIdCufyBzk8/qtt/zfBQ+JOx9ACHoRt9N4+KVLOjlJ7rFQ2oTJtd
# g5l/YgJquWx2AXY8jJY7+6lj2KeTkTElp1rrtHqoToBSr2CParxQTmOIm8DTqYJA
# GkPL8RMx
# SIG # End signature block
